
function Dial(pos, colors)
{
	this.pos = new Vector2(pos.x, pos.y);
	this.fromcolors = colors;
	this.tocolors = [0,0,0,0];

	// Keep the dial on screen.
	if (this.pos.x < 128)
		this.pos.x = 128;
	if (this.pos.x > screenWidth - 128)
		this.pos.x = screenWidth - 128;
	if (this.pos.y < 128)
		this.pos.y = 128;
	if (this.pos.y > screenHeight - 128)
		this.pos.y = screenHeight - 128;

	this.mouseDown = function(pos)
	{
		var dialpos = new Vector2(pos);
		dialpos.subtract(this.pos);
		
		var angle = Global.vectorToAngle(dialpos);
		var dist = Global.vectorToDist(dialpos);
		if (dist > 128)
			return "cancel";

		if (dist > 48 && dist < 84)
		{
			if (angle > -0.2 && angle < 0.2)
				this.mouseDownOnColor(0);
			if (angle > Math.PI / 2 - 0.2 && angle < Math.PI / 2 + 0.2)
				this.mouseDownOnColor(1);
			if (angle > Math.PI - 0.2 || angle < -Math.PI + 0.2)
				this.mouseDownOnColor(2);
			if (angle > -Math.PI / 2 - 0.2 && angle < - Math.PI / 2 + 0.2)
				this.mouseDownOnColor(3);
		}
		if (dist < 24)
			return "ok";

		return "continue";
	}

	this.mouseDownOnColor = function(color)
	{
		if (Input.keys[16])
		{
			if (this.tocolors[color] > 0)
			{
				this.fromcolors[color]++;
				this.tocolors[color]--;
			}
		}
		else
		{
			if (this.fromcolors[color] > 0)
			{
				this.fromcolors[color]--;
				this.tocolors[color]++;
			}
		}
	}

	this.render = function()
	{
		Global.render(Content.dial, this.pos);
		
		ctx.font="15px Arial Bold";
		ctx.textAlign = "center";
		ctx.textBaseline = "middle";
		
		ctx.save();
		ctx.translate(this.pos.x, this.pos.y);

        for (var i = 0; i < 4; i++)
        {
			if (this.fromcolors[i] == 0 && this.tocolors[i] == 0)
				continue;

            var angle = (i / 4) * 2 * Math.PI;
			var frompos = Global.angleDistToVector(angle, 36);
			var topos = Global.angleDistToVector(angle, 96);

			ctx.fillStyle="#FFFFFF";
			ctx.fillText(this.fromcolors[i].toString(), frompos.x, frompos.y);
			ctx.fillText(this.tocolors[i].toString(), topos.x, topos.y);
        }
		
		ctx.restore();
	}
}
