
function Dude(type, n)
{
	this.findNextOffsetPos = function()
	{
		this.n1Off = new Vector2(this.n0Off);
		this.n1Off.x += 12 * (Math.random() - 0.5);
		this.n1Off.y += 12 * (Math.random() - 0.5);
		var angle = Global.vectorToAngle(this.n1Off);
		var dist = Global.vectorToDist(this.n1Off);
		if (dist > 20)
			dist = 20 + 20 - dist;
		this.n1Off = Global.angleDistToVector(angle, dist);
	}

	this.type = type;
	this.targn = null;
	this.n0 = n;
	this.n1 = null;
	this.n0Off = Global.rndPoint(20);
	this.n1Off = Vector2.Zero;
	this.npos = 0;
	this.token = null;
	this.carrying = false;
	this.dead = false;

	this.update = function()
	{
		if (this.targn != null)
		{
			if (this.n1 == null)
			{
				this.n1 = Global.path.findNext(this.n0, this.targn);
				if (this.n1 != null)
				{
					this.findNextOffsetPos();
				}
				else
				{
					// We have reached our destination.
					this.npos = 0;
					this.targn = null;

					// Check if we were carrying something back to the base.
					if (this.carrying)
					{
						this.token.putdown(this);
						this.carrying = false;
					}

					// Check if we have reached the token.
					if (this.token != null && this.token.node == this.n0)
					{
						if (this.token.carry(this))
							this.carrying = true;
					}
				}
			}
			else
			{
				this.move()
			}
		}
		else
		{
			if (this.carrying)
			{
				// If we're trying to carry a token then head back to base once it's been lifted.
				if (this.token.lifted())
					this.targn = Global.basenode;
			}
		}
	}

	this.move = function()
	{
		if (this.n1.barrier != null)
		{
			// Destroy the barrier instead of moving.
			this.n1.barrier.attack(this.type);
			return;
		}
		
		if (this.n1.enemy != null)
		{
			// Attack the enemy instead of moving.
			if (this.n1.enemy.attack(this.type))
				this.dead = true;
			return;
		}

		if (this.carrying)
			this.npos += 6;
		else
			this.npos += 8;
		
		var n0Pos = this.n0Pos();
		var n1Pos = this.n1Pos();
		var dist = Global.vectorToDist(n0Pos, n1Pos);
		if (this.npos > dist)
		{
			this.npos -= dist;
			this.n0 = this.n1;
			this.n0Off = this.n1Off;
			this.n1 = null;
		}
	}

	this.collect = function(token)
	{
		// Always carry stuff back to base.
		if (this.carrying)
			return;

		this.moveTo(token.node);
		this.token = token;
	}

	this.moveTo = function(n)
	{
		// Always carry stuff back to base.
		if (this.carrying)
			return;

		Global.path.showPath(this.n0, n);

		this.targn = n;
		if (this.n1 != null && this.n1.barrier != null)
			this.n1 = null;

		this.targettoken = null;
	}

	this.render = function()
	{
		Global.render(Content.dudes[this.type], this.currentPos());
	}

	this.renderCircle = function()
	{
		Global.render(Content.circle, this.currentPos());
	}

	this.currentPos = function()
	{
		var n0Pos = this.n0Pos();

		if (this.n1 != null)
		{
			var n1Pos = this.n1Pos();
			var angle = Global.vectorToAngle(n0Pos, n1Pos);
			var vector = Global.angleDistToVector(angle, this.npos);
			return new Vector2(n0Pos.x + vector.x, n0Pos.y + vector.y);
		}
		else
		{
			return new Vector2(n0Pos.x, n0Pos.y);
		}
	}

	this.n0Pos = function()
	{
		var pos = new Vector2(this.n0.pos);
		pos.add(this.n0Off);
		return pos;
	}

	this.n1Pos = function()
	{
		var pos = new Vector2(this.n1.pos);
		pos.add(this.n1Off);
		return pos;
	}
}
