
var canvas;
var ctx;
var screenWidth;
var screenHeight;
var ticker;

var levelnumber;
var level;
var teamcolors;


function step()
{
	update();
	render();
}

function update()
{
	ticker++;
	var retval = level.update();
	if (retval == "restart")
		restartLevel();
	if (retval == "nextlevel")
	{
		levelnumber++;
		if (levelnumber == 1)
			teamcolors[1] += 3;
		if (levelnumber == 2)
			teamcolors[2] += 3;
		if (levelnumber == 3)
			teamcolors[3] += 3;
		restartLevel();
	}
}

function render()
{
	ctx.fillStyle="#000000";
	ctx.fillRect(0, 0, canvas.width, canvas.height);

	level.render();
}

function restartLevel()
{
	if (levelnumber == 0)
		level = new Level0();
	if (levelnumber == 1)
		level = new Level1();
	if (levelnumber == 2)
		level = new Level2();
	if (levelnumber == 3)
		level = new Level3();
	if (levelnumber == 4)
		level = new Level4();
	if (levelnumber == 5)
		alert("Well done, you finished the game!");
}

function initGame()
{
	//teamcolors = [30, 26, 18, 12];
	teamcolors = [5, 0, 0, 0];

	levelnumber = 0;
	restartLevel();
}

function handleKeyDown(evt)
{
	Input.keys[evt.keyCode] = true;
}

function handleKeyUp(evt)
{
	Input.keys[evt.keyCode] = false;
}

function handleMouseMove(evt)
{
	var rect = canvas.getBoundingClientRect()
	Input.mousex = evt.clientX - rect.left;
	Input.mousey = evt.clientY - rect.top;
}

function handleMouseDown(evt)
{
	var rect = canvas.getBoundingClientRect()
	var x = evt.clientX - rect.left;
	var y = evt.clientY - rect.top;
	var pos = new Vector2(x, y);

	level.mouseDown(pos);

	Input.mousedown = true;
}

function handleMouseUp(evt)
{
	var rect = canvas.getBoundingClientRect()
	var x = evt.clientX - rect.left;
	var y = evt.clientY - rect.top;
	var pos = new Vector2(x, y);

	level.mouseUp(pos);

	Input.mousedown = false;
}

canvas = document.createElement("canvas");
ctx = canvas.getContext('2d');
canvas.width = 1024;
canvas.height = 720;
document.body.appendChild(canvas);

screenWidth = canvas.width;
screenHeight = canvas.height;

ticker = 0;

window.addEventListener('keydown',handleKeyDown,true);
window.addEventListener('keyup',handleKeyUp,true);

window.addEventListener('mousemove',handleMouseMove,false);
window.addEventListener('mousedown',handleMouseDown,false);
window.addEventListener('mouseup',handleMouseUp,false);

// disable vertical scrolling from arrows :)
document.onkeydown=function(){return event.keyCode!=38 && event.keyCode!=40 && event.keyCode!=32}

initGame();
setInterval(step, 1000 / 60);



