﻿
function Global()
{
}

Global.path = null;
Global.basenode = null;

Global.angleDistToVector = function(angle, distance)
{
    var x = distance * Math.sin(angle);
    var y = -distance * Math.cos(angle);
    return new Vector2(x, y);
}

Global.vectorToAngle = function(v0, v1)
{
	if (arguments.length == 2)
	{
		var diff = new Vector2(v1);
		diff.subtract(v0);
		return Math.atan2(diff.x, -diff.y);
	}
	else
	{
		return Math.atan2(v0.x, -v0.y);
	}
}

Global.vectorToDist = function(v0, v1)
{
	if (arguments.length == 2)
	{
		var diff = new Vector2(v1);
		diff.subtract(v0);
		return Math.sqrt(diff.x * diff.x + diff.y * diff.y);
	}
	else
	{
		return Math.sqrt(v0.x * v0.x + v0.y * v0.y);
	}
}

Global.rndPoint = function(dist)
{
	var angle = Math.random() * 2 * Math.PI;
	dist *= Math.random();
	return Global.angleDistToVector(angle, dist);
}


Global.render = function(img, pos, angle, alpha)
{
	if (arguments.length < 4)
		alpha = 1;

	ctx.save();
	ctx.globalAlpha = alpha;
	ctx.translate(pos.x, pos.y);
	ctx.rotate(angle);
	ctx.drawImage(img, -img.width / 2, -img.height / 2);
	ctx.restore();
}

Global.drawText = function(text, pos, size, color, outcolor)
{
    ctx.font = size.toString() + "pt Verdana";

	ctx.fillStyle = color;
    ctx.strokeStyle = outcolor;
	ctx.lineWidth = size / 10;
	
	ctx.beginPath();
    ctx.strokeText(text, pos.x, pos.y);
    ctx.fill();
	ctx.stroke();
	
    ctx.fillText(text, pos.x, pos.y);
}

Global.rndInt = function(max)
{
	return Math.floor(Math.random() * max);
}
