
function Group(dudes)
{
	if (arguments.length == 0)
		this.dudes = new Array();
	else
		this.dudes = dudes;

	this.update = function()
	{
		// Remove any dudes that are carrying stuff or are dead from the group.
		for (var i = 0; i < this.dudes.length; i++)
		{
			if (this.dudes[i].carrying)
				this.dudes.splice(i--, 1);
			else if (this.dudes[i].dead)
				this.dudes.splice(i--, 1);
		}

		return this.dudes.length > 0;
	}

	this.collect = function(token)
	{
		for (var i = 0; i < this.dudes.length; i++)
		{
			this.dudes[i].collect(token);
		}
	}

	this.moveTo = function(n)
	{
		for (var i = 0; i < this.dudes.length; i++)
		{
			this.dudes[i].moveTo(n);
		}
	}

	this.split = function(colors)
	{
		var newgroup = new Group();
		
		for (var i = 0; i < this.dudes.length; i++)
		{
			if (colors[this.dudes[i].type] > 0)
			{
				colors[this.dudes[i].type]--;

				// Move this dude into the new group.
				newgroup.dudes.push(this.dudes[i]);
				this.dudes.splice(i--, 1);
			}
		}

		return newgroup;
	}

	this.getColors = function()
	{
		var colors = [0,0,0,0];

		for (var i = 0; i < this.dudes.length; i++)
		{
			colors[this.dudes[i].type]++;
		}

		return colors;
	}

	this.render = function()
	{
		for (var i = 0; i < this.dudes.length; i++)
		{
			this.dudes[i].renderCircle();
		}
	}
}
