
function Level()
{
	this.init = function()
	{
		this.background = null;
		this.dudes = new Array();
		this.barriers = new Array();
		this.enemies = new Array();
		this.tokens = new Array();
		this.goal = null;
		this.selectedgroup = null;
	
		this.dial = null;
		this.dragfrom = null;
		this.dragto = null;
		this.splitcollect = null;
		this.splitmoveto = null;

		this.timeleft = 1000;
	}

	this.spawnPeeps = function()
	{
		for (var i = 0; i < 4; i++)
		{
			for (var j = 0; j < teamcolors[i]; j++)
			{
				newdude = new Dude(i, Global.basenode);
				this.dudes.push(newdude);
			}
		}
	}
	
	this.newConnection = function(n0, n1)
	{
		var dist = Global.vectorToDist(n0.pos, n1.pos);
		var split = Math.floor(dist / 50);
		var lastnode = n0;
		
		for (var i = 0; i < split; i++)
		{
			var newpos = new Vector2(n1.pos);
			newpos.subtract(n0.pos);
			newpos.divide(1 + split);
			newpos.multiply(1 + i);
			newpos.add(n0.pos);
			var newnode = Global.path.addNode(newpos.x, newpos.y);
			Global.path.connectNodes(lastnode, newnode);
			lastnode = newnode;
		}
		
		Global.path.connectNodes(lastnode, n1);
	}

	this.newNode = function(x, y, c0, c1, c2, c3)
	{
		var n = Global.path.addNode(x, y);

		if (arguments.length > 2)
			this.newConnection(n, c0);
		if (arguments.length > 3)
			this.newConnection(n, c1);
		if (arguments.length > 4)
			this.newConnection(n, c2);
		if (arguments.length > 5)
			this.newConnection(n, c3);

		return n;
	}

	this.newCircle = function(x, y)
	{
		var nodes = new Array();
		var centrenode = Global.path.addNode(x, y)
		nodes.push(centrenode);

		var oldnode = null;

		for (var i = 0; i < 8; i++)
		{
			var newpos = new Vector2(x, y);
			var angle = (i / 8) * 2 * Math.PI;
			newpos.add(Global.angleDistToVector(angle, 70));

			var newnode = Global.path.addNode(newpos.x, newpos.y);
			nodes.push(newnode);
			
			Global.path.connectNodes(centrenode, newnode);
			if (oldnode != null)
				Global.path.connectNodes(oldnode, newnode);
			if (i == 7)
				Global.path.connectNodes(newnode, nodes[1]);

			oldnode = newnode;
		}

		return nodes;
	}
	
	this.update = function()
	{
		if (this.timeleft == 0)
		{
			if (Input.keys[82])
				return "restart";
			if (this.goal == null && Input.keys[67])
			{
				// Count the number of each color we have left.
				teamcolors[0] = 0;
				teamcolors[1] = 0;
				teamcolors[2] = 0;
				teamcolors[3] = 0;

				for (var i = 0; i < this.dudes.length; i++)
					teamcolors[this.dudes[i].type]++;

				return "nextlevel";
			}
			
			return;
		}

		if (Input.keys[27])
			this.selectedgroup = null;

		if (this.selectedgroup != null)
		{
			if (!this.selectedgroup.update())
				this.selectedgroup = null;
		}

		if (this.dragfrom != null)
		{
			this.dragto = new Vector2(Input.mousex, Input.mousey);
		}

		Global.path.update();
		
		for (var i = 0; i < this.barriers.length; i++)
		{
			this.barriers[i].update();

			if (this.barriers[i].destroyed())
				this.barriers.splice(i--, 1);
		}
		
		for (var i = 0; i < this.enemies.length; i++)
		{
			this.enemies[i].update();

			if (this.enemies[i].destroyed())
				this.enemies.splice(i--, 1);
		}

		if (Input.keys[32])
		{
			this.updateRealTime();
			this.timeleft--;
		}
	}

	this.updateRealTime = function()
	{
		for (var i = 0; i < this.dudes.length; i++)
		{
			this.dudes[i].update();
			if (this.dudes[i].dead)
				this.dudes.splice(i--, 1);
		}
		
		for (var i = 0; i < this.tokens.length; i++)
		{
			this.tokens[i].update();

			if (this.tokens[i].returned())
			{
				// Token has been carried back to the base.
				for (var j = 0; j < this.tokens[i].value; j++)
				{
					var newdude = new Dude(this.tokens[i].color, Global.basenode);
					this.dudes.push(newdude);
				}

				this.tokens.splice(i--, 1);
			}
		}

		if (this.goal != null && this.goal.returned())
			this.goal = null;
	}

	this.mouseDown = function(pos)
	{
		this.dragfrom = pos;
	}

	this.mouseUp = function(pos)
	{
		if (this.dial != null)
		{
			var result = this.dial.mouseDown(pos);
			if (result == "cancel")
				this.dial = null;

			if (result == "ok")
			{
				if (this.dial.tocolors[0] > 0 ||
					this.dial.tocolors[1] > 0 ||
					this.dial.tocolors[2] > 0 ||
					this.dial.tocolors[3] > 0)
				{
					// Create a new group with the given colors.
					var newgroup = this.selectedgroup.split(this.dial.tocolors);

					// Execute the move command.
					if (this.splitcollect != null)
						newgroup.collect(this.splitcollect);
					else
						newgroup.moveTo(this.splitmoveto);
				}

				this.dial = null;
			}
			this.dragfrom = null;
			this.dragto = null;
			return;
		}

		var dist = Global.vectorToDist(this.dragfrom, this.dragto);
		if (this.dragto == null || dist < 4)
		{
			this.click(pos);
		}
		else if (this.dragto != null)
		{
			this.selectedgroup = null;

			var dudelist = new Array();

			var minx = Math.min(this.dragfrom.x, this.dragto.x);
			var miny = Math.min(this.dragfrom.y, this.dragto.y);
			var maxx = Math.max(this.dragfrom.x, this.dragto.x);
			var maxy = Math.max(this.dragfrom.y, this.dragto.y);
			
			for (var i = 0; i < this.dudes.length; i++)
			{
				var dudepos = this.dudes[i].currentPos();
				if (dudepos.x > minx && dudepos.x < maxx &&
					dudepos.y > miny && dudepos.y < maxy)
					dudelist.push(this.dudes[i]);
			}

			if (dudelist.length > 0)
			{
				this.selectedgroup = new Group(dudelist);
			}
		}

		this.dragfrom = null;
		this.dragto = null;
	}

	this.click = function(pos)
	{
		if (this.selectedgroup == null)
			return;
			
		var besttoken = this.findNearestToken(pos);
		var node = Global.path.findNearestNode(pos);
		if (besttoken != null || node != null)
		{
			if (Input.keys[16])
			{
				var colors = this.selectedgroup.getColors();
				this.dial = new Dial(pos, colors);
				if (besttoken != null)
				{
					this.splitcollect = besttoken;
					this.splitmoveto = null;
				}
				else
				{
					this.splitcollect = null;
					this.splitmoveto = node;
				}
			}
			else
			{
				if (besttoken != null)
					this.selectedgroup.collect(besttoken);
				else
					this.selectedgroup.moveTo(node);
			}
		}
	}

	this.findNearestToken = function(pos)
	{
		var besttoken = null;
		var bestdist = Number.MAX_VALUE;

		if (this.goal != null)
		{
			var goalpos = this.goal.currentPos();
			var goaldist = Global.vectorToDist(goalpos, pos);
			if (goaldist < 20)
				return this.goal;
		}

		for (var i = 0; i < this.tokens.length; i++)
		{
			var tokenpos = this.tokens[i].currentPos();
			var newdist = Global.vectorToDist(tokenpos, pos);
			if (newdist < 16 && newdist < bestdist)
			{
				bestdist = newdist;
				besttoken = this.tokens[i];
			}
		}

		return besttoken;
	}

	this.render = function()
	{
		ctx.fillStyle="#000000";
		ctx.fillRect(0, 0, screenWidth, screenHeight);
		
		ctx.drawImage(Content.background, 0, 0);
		
		Global.path.render();
			
		for (var i = 0; i < this.barriers.length; i++)
			this.barriers[i].render();
			
		for (var i = 0; i < this.enemies.length; i++)
			this.enemies[i].render();

		ctx.drawImage(this.background, 0, 0);
		
		for (var i = 0; i < this.dudes.length; i++)
			this.dudes[i].render();

		if (this.selectedgroup != null)
			this.selectedgroup.render();
			
		for (var i = 0; i < this.tokens.length; i++)
			this.tokens[i].render();

		if (this.goal != null)
			this.goal.render();

		if (this.dial != null)
			this.dial.render();

		if (this.dragto != null)
		{
			ctx.strokeStyle="#808080";
			ctx.beginPath();
			ctx.moveTo(this.dragfrom.x, this.dragfrom.y);
			ctx.lineTo(this.dragto.x, this.dragfrom.y);
			ctx.lineTo(this.dragto.x, this.dragto.y);
			ctx.lineTo(this.dragfrom.x, this.dragto.y);
			ctx.lineTo(this.dragfrom.x, this.dragfrom.y);
			ctx.stroke();
		}
			
		ctx.font="30px Arial Bold";
		ctx.textAlign = "center";
		ctx.textBaseline = "middle";
		
		Global.drawText(this.timeleftString(), new Vector2(screenWidth / 2, 50), 30, "#000000", "#FFFFFF");

		if (this.selectedgroup != null)
			this.drawPeepCount();

		if (this.timeleft == 0)
			this.drawEndLevel();
	}

	this.drawPeepCount = function()
	{
		var colors = this.selectedgroup.getColors();

		ctx.font="15px Arial Bold";
		ctx.textAlign = "center";
		ctx.textBaseline = "middle";
		
		if (colors[0] > 0)
			Global.drawText(colors[0].toString(), new Vector2(48, screenHeight - 16), 15, "#FF0000", "#000000");
		if (colors[1] > 0)
			Global.drawText(colors[1].toString(), new Vector2(96, screenHeight - 16), 15, "#00FF00", "#000000");
		if (colors[2] > 0)
			Global.drawText(colors[2].toString(), new Vector2(144, screenHeight - 16), 15, "#0000FF", "#000000");
		if (colors[3] > 0)
			Global.drawText(colors[3].toString(), new Vector2(192, screenHeight - 16), 15, "#FFFF00", "#000000");
	}

	this.drawEndLevel = function()
	{
		var textpos = new Vector2(screenWidth / 2, screenHeight / 2);
		Global.drawText("Time's up!", textpos, 50, "#FF0000", "#000000");

		textpos.y += 80;

		if (this.goal != null)
		{
			Global.drawText("You failed to collect the artefact!", textpos, 30, "#FF0000", "#000000");
		}

		textpos.y += 60;
		Global.drawText("Press R to replay the level.", textpos, 30, "#FF0000", "#000000");
		
		if (this.goal == null)
		{
			textpos.y += 60;
			Global.drawText("Press C to continue to next level.", textpos, 30, "#FF0000", "#000000");
		}
	}

	this.timeleftString = function()
	{
		var milliseconds = Math.floor(this.timeleft % 100);
		var seconds = Math.floor((this.timeleft / 100) % 60);
		var millisecondsstring = ("00" + milliseconds.toString()).substr(-2);
		var secondsstring = ("00" + seconds.toString()).substr(-2);
		return secondsstring + "." + millisecondsstring;
	}
}
